
char is_prime[SIEVESIZE];
int primes[SIEVESIZE]; // number of primes >= x is about x / ln(x) (prime number theorem)

int i,n;
memset(is_prime,1,sizeof(is_prime));
is_prime[1]=is_prime[0]=0;

for (n=2; n*n<SIEVESIZE; n++)
	if(is_prime[n])
		for (i = n*n; i < SIEVESIZE; i += n)
			is_prime[i] = 0;

for (n=3,i=0; n < SIEVESIZE; n++)
	if(is_prime[n])
		primes[i++]=n;

char isprime(int n) {
	int i,k;
	if (n<MAXPRECALC) {
		return is_prime[n];
	} else {
		k=(int)sqrt((double)n);
		for (i=0; primes[i]<=k; i++)
			if (n%primes[i]==0)
				return 0;
		return 1;
	}
}


